zoukankan      html  css  js  c++  java
  • hdu 1142 A Walk Through the Forest(dijkstra)

    hdu 1142 A Walk Through the Forest

    http://acm.hdu.edu.cn/showproblem.php?pid=1142

    Problem Description
    Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer, his office is on one side of a forest, and his house is on the other. A nice walk through the forest, seeing the birds and chipmunks is quite enjoyable. 
    The forest is beautiful, and Jimmy wants to take a different route everyday. He also wants to get home before dark, so he always takes a path to make progress towards his house. He considers taking a path from A to B to be progress if there exists a route from B to his home that is shorter than any possible route from A. Calculate how many different routes through the forest Jimmy might take. 
     

    Input
    Input contains several test cases followed by a line containing 0. Jimmy has numbered each intersection or joining of paths starting with 1. His office is numbered 1, and his house is numbered 2. The first line of each test case gives the number of intersections N, 1 < N ≤ 1000, and the number of paths M. The following M lines each contain a pair of intersections a b and an integer distance 1 ≤ d ≤ 1000000 indicating a path of length d between intersection a and a different intersection b. Jimmy may walk a path any direction he chooses. There is at most one path between any pair of intersections. 
     

    Output
    For each test case, output a single integer indicating the number of different routes through the forest. You may assume that this number does not exceed 2147483647
     

    Sample Input
    5 6 1 3 2 1 4 2 3 4 3 1 5 12 4 2 34 5 2 24 7 8 1 3 1 1 4 1 3 7 1 7 4 1 7 5 1 6 7 1 5 2 1 6 2 1 0
     

    Sample Output
    2 4

    1.1为起点,2为终点,因为要走ab路时,必须保证那个条件,所以从终点开始使用单源最短路Dijkstra算法,就得到了最短的一条路,作为找路的最低限度。

    2.然后深搜每条路,看看满足题意的路径有多少条。当然,这个需要从起点开始搜,因为dis[i]数组中保存的都是该点到终点的最短距离。

    3.这样搜索之后,dp[1]就是从起点到终点所有满足题意的路径的条数。

    #include<iostream>
    using namespace std;
    #define INF 9999999
    #define MAX 1001
    int map[MAX][MAX];
    int dis[MAX],v[MAX],sum[MAX];
    void dijkstra(int s,int n)
    {
     int i,j,min,k;
     for(i=1;i<=n;i++)
      dis[i]=map[s][i];
     memset(v,0,sizeof(v));
     v[s]=1;
     dis[s]=0;
     for(i=2;i<=n;i++)
     {
      k=s;
      min=INF;
      for(j=1;j<=n;j++)
       if(!v[j]&&min>dis[j])
       {
        min=dis[j];
        k=j;
       }
      v[k]=1;
      for(j=1;j<=n;j++)
       if(!v[j]&&dis[j]>dis[k]+map[k][j])
        dis[j]=dis[k]+map[k][j];
     }
    }
    int dfs(int s,int n)
    {
     int i;
     if(sum[s])
      return sum[s];
     if(s==2)
      return 1;
     for(i=1;i<=n;i++)
      if(map[s][i]!=INF)
      {
       if(dis[s]>dis[i])
        sum[s]+=dfs(i,n);
      }
     return sum[s];
    }
    int main()
    {
     int n,m;
     while(~scanf("%d",&n),n)
     {
      scanf("%d",&m);
      int a,b,q;
      int i,j;
      for(i=1;i<=n;i++)
       for(j=1;j<=n;j++)
        map[i][j]=INF;
      while(m--)
      {
       scanf("%d%d%d",&a,&b,&q);
       if(map[a][b]==INF||map[a][b]>q)
        map[a][b]=map[b][a]=q;
      }
      dijkstra(2,n);
      memset(sum,0,sizeof(sum));
      printf("%d\n",dfs(1,n));
     }
     return 0;
    }

  • 相关阅读:
    idea解决Maven jar依赖冲突(四)
    代码规范:idea上添加阿里巴巴Java开发插件
    一起MySQL时间戳精度引发的血案
    JVM Code Cache空间不足,导致服务性能变慢
    通过SOFA看Java服务端如何实现运行时的模块化
    谈谈我对SOFA模块化的理解
    谈谈我对SOFA模块化的理解
    一文谈尽边缘计算
    JVM调优实战:G1中的to-space exhausted问题
    JVM调优实战:G1中的to-space exhausted问题
  • 原文地址:https://www.cnblogs.com/crazyapple/p/2999444.html
Copyright © 2011-2022 走看看